/*
 * Copyright (C) 2011 by Robert Cousins
 * All Rights Reserved
 *
 * $Id: rec_decode.c,v 1.1 2011/04/26 22:28:02 rec Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>		/* for strlen(3) */
#include "data.h"
#include "ac.h"

#define IN_SIZE (1<<24)

AC_Handle ac;
char buffer[IN_SIZE];
int in_len;

void load_data()
{
  int i;
  ac = ac_alloc();

  for (i = 0; i < num_zeros; i++)
    ac_add_string(ac,zeros[i],strlen(zeros[i]), i+i);
  for (i = 0; i < num_ones; i++)
    ac_add_string(ac,ones[i],strlen(ones[i]), i+i+1);
  ac_prep(ac);
}

void load_input()
{
  int ch;
  char *next;

  next = buffer;
  in_len = 0;

  while ((ch = fgetc(stdin)) != EOF) {
    *next++ = ch;
    in_len++;
  }
  *next = '\0';
}

void search_input()
{
  char *p, *q;
  unsigned int len, id; 
  int ch, count, i;

  p = buffer;

  ch = count = 0;
  while (1) {
    ac_search_init(ac, p, in_len);
    if (ac_search(ac, &p, &len, &id) == 0) break;

    p += len;
    in_len -= len;

    ch >>= 1;
    if (id &  0x01) ch |= 0x80;

    if (++count == 8) {
      fputc(ch,stdout);
      ch = 0;
      count = 0;
    }
  }
}

int main(int argc, char *argv[])
{
  load_data();
  load_input();
  search_input();
  exit(0);
}
