/*
 * Copyright (C) 2011 by Robert Cousins
 * All Rights Reserved
 *
 * $Id: rec_encode.c,v 1.1 2011/04/26 22:28:02 rec Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include "data.h"

int next_zero = 0;
int next_one = 0;

void shuffle_zeros()
{
  int i,j,k;
  char *t;

  for (k = 0; k < 10; k++)
    for (i = 0; i < num_zeros; i++) {
      j = random() % num_zeros;
      t = zeros[i];
      zeros[i] = zeros[j];
      zeros[j] = t;
    }
}

void shuffle_ones()
{
  int i,j,k;
  char *t;

  for (k = 0; k < 10; k++)
    for (i = 0; i < num_ones; i++) {
      j = random() % num_ones;
      t = ones[i];
      ones[i] = ones[j];
      ones[j] = t;
    }
}

void put_next_bit(int bit)
{
  if (bit) {
    fputs(ones[next_one++], stdout);
    if (next_one >= num_ones) {
      shuffle_ones();
      next_one = 0;
    }
  } else {
    fputs(zeros[next_zero++], stdout);
    if (next_zero >= num_zeros) {
      shuffle_zeros();
      next_zero = 0;
    }
  }
}
int main(int argc, char *argv[])
{
  int ch, i;

  srandomdev();		/* initialize PRNG */
  shuffle_zeros();
  shuffle_ones();
  while ((ch = getc(stdin)) != EOF) {
    for (i = 0; i < 8; i++) {
      put_next_bit(ch & 1);
      ch >>= 1;
    }
  }
  exit(0);
}
